<?php
/**
 * @package    JMyLife
 * @subpackage Components
 * @version    1.0.16
 * @copyright  2009-2010 Jeff Channell
 * components/com_jmylife/libraries/common.php
 * @license

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );
// this is defined here to be universal ;)
if (!defined('JPATH_JMYLIFEIMAGEFILES')) define('JPATH_JMYLIFEIMAGEFILES', JPATH_ROOT.DS.'images'.DS.'jmylife');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');

/**
 * HTML Common class JmylifeCommon
 *
 * @package    JMyLife
 */
class JmylifeCommon
{
	function votelinks( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$goodText = $_JMLConfig->get('votegood_text');
		$badText  = $_JMLConfig->get('votebad_text');
		$linkattr = array( 'class'=>"comJMyLifeItemVoteLink", 'rel'=>'nofollow' );
		$goodlink = $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votegood&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			( strlen( $goodText ) > 0 ? $goodText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEGOOD') ).' ('.$item->votes1.')',
			array('class'=>"comJMyLifeItemVoteLink comJMyLifeItemVoteLinkGood", 'rel'=>'nofollow')
		);
		$badlink = $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votebad&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			( strlen( $badText ) > 0 ? $badText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEBAD') ).' ('.$item->votes2.')',
			array('class'=>"comJMyLifeItemVoteLink comJMyLifeItemVoteLinkBad", 'rel'=>'nofollow')
		);
		return $goodlink.(0 == $_JMLConfig->get('good_votes_only', 0) ? ' - ' .$badlink : '');
	}
	function graphicvote( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$goodText = $_JMLConfig->get('votegood_text');
		$badText  = $_JMLConfig->get('votebad_text');
		$linkattr = array( 'class'=>"comJMyLifeItemGraphicVoteLink", 'rel'=>'nofollow' );
		return $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votegood&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			'<img src="'.JURI::base().'components/com_jmylife/assets/images/voteup-'.$_JMLConfig->get('graphical_voting_size','48').'.png"/><span class="comJMyLifeItemGraphicVoteCount">'.$item->votes1.'</span><span class="comJMyLifeItemGraphicVoteText">'.( strlen( $goodText ) > 0 ? $goodText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEGOOD') ).'</span>',
			$linkattr ).( $_JMLConfig->get( 'good_votes_only', 0 ) == 0 ? ' - ' .
		$html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=votebad&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
			'<img src="'.JURI::base().'components/com_jmylife/assets/images/votedown-'.$_JMLConfig->get('graphical_voting_size','48').'.png"/><span class="comJMyLifeItemGraphicVoteCount">'.$item->votes2.'</span><span class="comJMyLifeItemGraphicVoteText">'.( strlen( $badText ) > 0 ? $badText : JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_VOTEBAD') ).'</span>',
			$linkattr ) : '' )
		;
	}
	function reportstorylink( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// this should only work if email is configured & enabled, so check first
		if( $_JMLConfig->getInt( 'email_enabled', 0 ) == 1 && strlen( $_JMLConfig->get( 'email_to' ) ) > 0 )
		{
			return $html->link(
				JRoute::_('index.php?option=com_jmylife&controller=ajax&task=reportstory&sid='.$item->id.'&'.JUtility::getToken().'=1', false),
				JText::_('COM_JMYLIFE_STORY_REPORT'),
				array( 'class'=>"reportstory_link", 'rel'=>'nofollow' )
			);
		}
		return '';
	}
	function reportcommentlink( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->link(
			JRoute::_('index.php?option=com_jmylife&controller=ajax&task=report&cid='.$item->id.'&'.JUtility::getToken().'=1', false),
			JText::_('COM_JMYLIFE_COMMENT_REPORT'),
			array( 'class'=>"report_link", 'rel'=>'nofollow' )
		);
	}
	function itemfooter( &$item )
	{
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		// get user
		$user =& JFactory::getUser();
		$database =& JFactory::getDBO();
		$url = $item->fullstorylink;
		// init output
		$output = '';
		// hide/show button
		// only if enabled in config - since 1.0.2
		if( $_JMLConfig->getInt( 'footer_toggle' ) == 1 )
		{
			$output .= '<div class="comJMyLifeItemFooterToggle">+</div>';
		}

		// wrapper for footer contents
		$output .= '<div class="comJMyLifeItemFooterWrapper">';
			// these items reordered in 1.0.9 to combat some weird IE float bug
			// since 1.0.4
			$output .= JmylifeCommon::twitlink( $item );
			// add facebook footer (actual check for config done in fblink() below
			$output .= JmylifeCommon::fblink( $item );
		if( $_JMLConfig->getInt( 'reportlink' ) == 1 )
		{
			$output .= JmylifeCommon::reportstorylink( $item );
		}
		// other than this, we'll have different items for users/guests
		if( $user->guest )
		{
			// since 1.0.5 this is optional
			if( $_JMLConfig->getInt( 'show_signupitem' ) == 1 )
			{
				// get link for item from menu
				$database->setQuery( 'SELECT `link` FROM `#__menu` WHERE `id` = '.$_JMLConfig->getInt( 'signupitem' ), 0, 1 );
				// if no link use base, fixed in 1.0.9
				if (!($link = $database->loadResult())) {
					$link = JURI::base();
				} else {
					JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
					$helper = JmylifeUrlHelper::getInstance();
					// append Itemid
					$link .= $helper->q($link).'Itemid='.$_JMLConfig->getInt('signupitem');
				}
				$link = JRoute::_($link, false);
				$output .= $html->link($link, JText::_('COM_JMYLIFE_STORY_SIGNUPFORMORE'), array('class' => 'signup_link'));
			}
		}
		// registered user
		else
		{
			// check if user is subscribed to the story & add a subscription link
			$query = 'SELECT `id` FROM `#__jmylife_stories_subscriptions` WHERE `uid` = '.$user->id.' AND `sid` = '.$item->id;
			$database->setQuery( $query );
			if( intval( $database->loadResult() ) > 0 )
			{
				$output .= $html->link(
						JRoute::_('index.php?option=com_jmylife&controller=ajax&task=unsubscribe&sid='.$item->id.'&'.JUtility::getToken().'=1&tmpl=component', false),
						JText::_('COM_JMYLIFE_STORY_UNSUBSCRIBE'),
						array( 'class'=>"unsubscribe_link", 'rel'=>'nofollow' )
				);
			}
		}
		// end wrapper
		$output .= '</div>';

		// clear, in case...
		$output .= '<div class="comJMyLifeItemFooterClear"></div>';

		// all done!
		return $output;
	}
	/**
	 * fblink
	 * @param  object   item
	 * @return string   html for facebook link
	 */
	function fblink(&$item) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$helper = JmylifeUrlHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if ($_JMLConfig->getInt('fblink')) {
			$url = $helper->clean($item->fullstorylink, true);
			$url = "http://www.facebook.com/sharer.php?u=$url";
			$attr = array('class'=>'fb_share_link', 'target'=>'_blank');
			if ($_JMLConfig->getInt('fbmodal')) {
				$attr = array('class'=>'fb_share_link modal', 'rel'=>'{handler:\'iframe\',size:{x:626,y:436}}');
			}
			return $html->link($url, JText::_('COM_JMYLIFE_STORY_SHAREONFACEBOOK'), $attr);
		}
		return '';
	}
	/**
	 * twitlink
	 * @param  object   item
	 * @return string   html for twitter link
	 */
	function twitlink(&$item) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		$helper = JmylifeUrlHelper::getInstance();
		$string = JmylifeStringHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		if ($_JMLConfig->getInt('twitlink')) {
			$url = $helper->clean($item->fullstorylink, true);
			$text = urlencode($string->shorten(JText::sprintf('COM_JMYLIFE_STORY_TWITTERSHARE', $item->fulltext), 137, false));
			$link = "http://twitter.com/home?status={$text}";
			$attr = array('class'=>'twit_share_link', 'target'=>'_blank');
			return $html->link($link, JText::_('COM_JMYLIFE_STORY_SHAREONTWITTER'), $attr);
		}
		return '';
	}

	/**
	 * handlepath
	 * @since 1.0.9
	 *
	 * TODO: make this work better ;P
	 *       at some point this should check menu items thoroughly
	 */
	function handlepath()
	{
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		$_JMLConfig = JmylifeConfiguration::getInstance();
		$database =& JFactory::getDBO();
		$appl     =& JFactory::getApplication();
		$pathway  =& $appl->getPathway();
		$menu     =& JSite::getMenu();
		$active   =  $menu->getActive();
		// get vars from request
		$view   = JRequest::getCmd('view');
		$catid  = JRequest::getInt('catid',0);
		$id     = JRequest::getInt('id',0);
		$sort   = JRequest::getWord('sort','none');
		$rand   = JRequest::getInt('random',0);
		$Itemid = JRequest::getInt('Itemid',0);
		$start  = $_JMLConfig->get('jmylife_name',JText::_('COM_JMYLIFE_CONFIGURATION_DEFAULT_SITENAME'));
		// handle crumbs
		// check active to see where the user is
		// if it's a JML pathway item skip root pathway
		if ('com_jmylife' != @$active->query['option']) {
			// send initial crumb for JMyLife
			$pathway->addItem($start, JRoute::_( 'index.php?option=com_jmylife&view=list&Itemid='.$helper->category(0)));
		}
		switch ($view) {
			case 'list':
				if (0 < $catid && @$active->query['catid'] != $catid) {
					// get category
					$database->setQuery('SELECT `name` FROM `#__jmylife_categories` WHERE id = '.$catid);
					if ($catname = $database->loadResult()) {
						$pathway->addItem($catname, JRoute::_('index.php?option=com_jmylife&view=list&catid='.$catid.'&Itemid='.$helper->category($catid)));
					}
				}
				if (@$active->query['sort'] != $sort) {
					if ('best' == $sort) {
						$pathway->addItem(JText::_('COM_JMYLIFE_SEF_BEST'), JRoute::_('index.php?option=com_jmylife&view=list&sort=best&Itemid='.$helper->category(0, 'best')));
					}
					else if ('worst' == $sort) {
						$pathway->addItem(JText::_('COM_JMYLIFE_SEF_WORST'), JRoute::_('index.php?option=com_jmylife&view=list&sort=worst&Itemid='.$helper->category(0, 'worst')));
					}
				}
				break;
			case 'item':
				// handle random
				if ($rand) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_RANDOM'), JRoute::_('index.php?option=com_jmylife&view=item&random=1&Itemid='.$helper->story(0, 1)));
				} else {
					// get data from database
					$database->setQuery('SELECT cat.`name` AS catname, cat.`id` AS catid, s.`title`, s.`user_alias` FROM `#__jmylife_categories` AS cat LEFT JOIN `#__jmylife_stories` AS s ON ( cat.`id` = s.`catid` ) WHERE s.`id` = '.$id.' GROUP BY cat.`id`');
					if ($data = $database->loadObject()) {
						$pathway->addItem($data->catname, JRoute::_('index.php?option=com_jmylife&view=list&catid='.$data->catid.'&Itemid='.$helper->category($data->catid)));
						// now add story
						// add story title if present & allowed, otherwise use "story by" text
						$storylink = JRoute::_('index.php?option=com_jmylife&view=item&id='.$id.'&Itemid='.$helper->story($data));
						if (strlen($data->title)) {
							$pathway->addItem($data->title, $storylink);
						} else {
							$pathway->addItem(JText::sprintf('COM_JMYLIFE_STORY_TITLE', $data->user_alias), $storylink);
						}
					}
				}
				break;
			case 'submit':
				if (@$active->query['view'] != $view) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_SUBMIT'), JRoute::_('index.php?option=com_jmylife&view=submit&Itemid='.$helper->view('submit')));
				}
				break;
			case 'categories':
				if (@$active->query['view'] != $view) {
					$pathway->addItem(JText::_('COM_JMYLIFE_SEF_CATEGORIES'), JRoute::_('index.php?option=com_jmylife&view=categories&Itemid='.$helper->view('categories')));
				}
				break;
		}
		return;
	}

	/**
	 * getSessionId
	 * @return  string
	 * @since   1.0.13
	 */
	function getSessionId()
	{
		$session =& JFactory::getSession();
		return $session->getId();
	}

	/**
	 * getRemoteData
	 * @param   string
	 * @param   array
	 * @return  string
	 * @since   1.0.11
	 */
	function getRemoteData($url, $data) {
		// TODO: rewrite this to allow POST data (not used currently)
		if (@ini_get('allow_url_fopen') && function_exists('file_get_contents') && !JmylifeCommon::_iscurlinstalled()) {
			return @file_get_contents($url);
		}
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_TIMEOUT, 120);
		// BUGFIX: safe_mode / open_basedir hates this
		if (!(@ini_get('open_basedir') || @ini_get('safe_mode'))) {
			@curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
		}
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $url);
		if (0 < count($data)) {
			curl_setopt($ch, CURLOPT_POST, count($data));
			curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));
		}
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Windows; U; MSIE 7.0; Windows NT 6.0; en-US)");
		$result = curl_exec($ch);
		curl_close($ch);
		return $result;
	}

	/**
	 * _iscurlinstalled
	 * @return   bool
	 * @since    1.0.13
	 * @from     http://mywordpress.com/function-curl-php-extension-loaded/
	 *           ( shortened, of course )
	 */
	function _iscurlinstalled() {
		return in_array('curl', get_loaded_extensions());
	}

	/**
	 * redirect
	 * @param   string   url
	 * @param   string   message
	 * @param   string   message type
	 * @param   bool     use 301
	 * @since   1.0.13
	 *
	 * used to combat 301 cache behavior of certain browsers
	 */
	function redirect($url, $msg='', $msgType='message', $perm=true) {
		$appl = JFactory::getApplication();
		if ($perm || headers_sent()) {
			$appl->redirect($url, $msg, $msgType);
		} else {
			// pass message queue
			$queue = $appl->getMessageQueue();
			$session =& JFactory::getSession();
			if (0 < strlen($msg)) {
				$queue[] = array('message' => $msg, 'type' => strtolower($msgType));
				$session->set('application.queue', $queue);
			}
			header('Location: ' . $url, TRUE, 307);
			$appl->close();
		}
	}

	/**
	 * loadModal
	 */
	function loadModal() {
		if ('feed' == JRequest::getVar('format')) {
			return;
		}
		$libPath = JURI::root().'components/com_jmylife/libraries/';
		$document =& JFactory::getDocument();
		$document->addScript( $libPath.'jquery/nyroModal/js/jquery.nyroModal-1.6.2.pack.js' );
		$document->addStyleSheet( $libPath.'jquery/nyroModal/styles/nyroModal.full.css' );
	}

	/**
	 * DEPRECIATED
	 * these functions had their code transplanted into helpers
	 * all instances of these functions should be removed later
	 */
	/* replaced by JmylifeHtmlHelper */
	function buildLink( $href, $text, $attributes=null ) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->link($href, $text, $attributes);
	}
	function alert($string) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->alert($string);
	}
	function clean($str='', $quotes=ENT_QUOTES, $charset='UTF-8') {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->clean($str, $quotes, $charset);
	}
	function unclean($str='', $quotes=ENT_QUOTES, $charset='UTF-8') {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->unclean($str, $quotes, $charset);
	}
	function parseBBCode($str, $strip=false) {
		JLoader::import('components.com_jmylife.helpers.html', JPATH_ADMINISTRATOR, '');
		$html = JmylifeHtmlHelper::getInstance();
		return $html->fromBB($str, $strip);
	}
	/* replaced by JmylifeEmailHelper */
	function sendMail($email, $body, $subject, $html=false) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->send($email, $body, $subject, $html);
	}
	function notifyAuthorPending($sid, $email) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->authorPending($sid, $email);
	}
	function notifyAuthorPublished($sid, $email) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->authorPublished($sid, $email);
	}
	function notifyCommentSubscribers($cid) {
		JLoader::import('components.com_jmylife.helpers.email', JPATH_ADMINISTRATOR, '');
		$mail = JmylifeEmailHelper::getInstance();
		$mail->commentSubscribers($cid);
	}
	/* replaced by JmylifeVersionHelper */
	function checkForUpdate($force=false) {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->checkForUpdate($force);
	}
	function updateBar() {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->updateBar();
	}
	function getCurrentVersion() {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->getCurrentVersion();
	}
	function getComparedVersions() {
		JLoader::import('components.com_jmylife.helpers.version', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeVersionHelper::getInstance();
		return $helper->getComparedVersions();
	}
	/* replaced by JmylifeStoryHelper */
	function buildStoryQuery($request, $published=1, $goodonly=0, $countonly=0) {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStoryHelper::getInstance();
		return $helper->buildQuery($request, $published, $goodonly, $countonly);
	}
	function prepareStory($object, $view, $break=true) {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStoryHelper::getInstance();
		return $helper->prepare($object, $view, $break);
	}
	function prepareStoryList($list, $view, $break=true) {
		JLoader::import('components.com_jmylife.helpers.story', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStoryHelper::getInstance();
		return $helper->prepareList($list, $view, $break);
	}
	/* replaced by JmylifeStringHelper */
	function breakLongWords($str) {
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->breakLongWords($str);
	}
	function shortenText($text, $count, $addbb=true) {
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->shorten($text, $count, $addbb);
	}
	function replaceStubs($text, $id, $type='story') {
		JLoader::import('components.com_jmylife.helpers.string', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeStringHelper::getInstance();
		return $helper->stubs($text, $id, $type);
	}
	function replaceEmailStubs($text, $id, $type='story') {
		return JmylifeCommon::replaceStubs($text, $id, $type);
	}
	/* replaced by JmylifeItemidHelper */
	function getStoryItemid($story, $random=0) {
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		return $helper->story($story, $random);
	}
	function getCategoryItemid($catid, $sort='none') {
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		return $helper->category($catid, $sort);
	}
	function getViewItemid($view) {
		JLoader::import('components.com_jmylife.helpers.itemid', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeItemidHelper::getInstance();
		return $helper->view($view);
	}
	/* replaced by JmylifeUrlHelper */
	function cleanUrl($string='', $urlencode=false) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->clean($string, $urlencode);
	}
	function validateUrl($url) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->validate($url);
	}
	function urlAppendChar($url) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->q($url);
	}
	function isUrlAvailable($url) {
		JLoader::import('components.com_jmylife.helpers.url', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeUrlHelper::getInstance();
		return $helper->isAvailable($url);
	}
	/* replaced by JmylifeCommentHelper */
	function buildCommentsQuery($id, $published=1, $latest=false) {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->buildQuery($id, $published, $latest);
	}
	function buildSingleCommentQuery($id) {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->buildQueryById($id);
	}
	function prepareComment($object, $view='') {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->prepare($object, $view);
	}
	function prepareCommentList($list, $view='') {
		JLoader::import('components.com_jmylife.helpers.comment', JPATH_ADMINISTRATOR, '');
		$helper = JmylifeCommentHelper::getInstance();
		return $helper->prepareList($list, $view);
	}

	/* end common */
}
